// Fill out your copyright notice in the Description page of Project Settings.


#include "Ammo/LMAmmo.h"

#include "Components/SphereComponent.h"
#include "Player/LMPlayer.h"

// Sets default values
ALMAmmo::ALMAmmo()
{
	PrimaryActorTick.bCanEverTick = true;
	AmmoMeshComponent = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("AmmoMeshComponent"));
	RootComponent = AmmoMeshComponent;
	CollisionSphere = CreateDefaultSubobject<USphereComponent>(TEXT("CollisionSphere"));
	CollisionSphere->SetupAttachment(RootComponent);
	CollisionSphere->OnComponentBeginOverlap.AddDynamic(this, &ALMAmmo::OnSphereOverlap);
	AmmoType = EAmmoType::EAT_RadishAmmo;
	AmmoAmount = 1;
	
}

void ALMAmmo::BeginPlay()
{
	Super::BeginPlay();
}

void ALMAmmo::OnSphereOverlap(UPrimitiveComponent* OverlappedComponent, AActor* OtherActor,
	UPrimitiveComponent* OtherComp, int32 OtherBodyIndex, bool bFromSweep, const FHitResult& SweepResult)
{
	if (ALMPlayer* Player = Cast<ALMPlayer>(OtherActor)) 
	{
		if (Player->PickUpAmmo(this))
		{
			Destroy();
		}
	}
}

void ALMAmmo::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}

