﻿#pragma once

#include "LMAmmoType.h"
#include "Kismet/KismetMathLibrary.h"
#include "Weapon/LMBulletTracer.h"
#include "LMAmmoData.generated.h"


USTRUCT(BlueprintType)
struct FLMAmmoData : public FTableRowBase
{
	GENERATED_BODY()

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EAmmoType AmmoType;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(ClampMin=1, ClampMax=1000, Uimin=1, Uimax=1000))
	int MaxAmmo = 32;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(ClampMin=0, Uimin=0))
	int AmmoCount = 8;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<ALMBulletTracer> BulletTracer;

	/**
	 * An utility method to add and
	 * @param Quantity The quantity of ammo to add.
	 */
	void AddAmmo(const int Quantity)
	{
		AmmoCount = UKismetMathLibrary::Clamp(AmmoCount + Quantity, 0, MaxAmmo);
	}
};
