﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameUserSettings.h"
#include "LMUserSettings.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE(FOnSettingsChangedSignature);

/**
 * 
 */
UCLASS(Blueprintable)
class LEGUMEMIX_API ULMUserSettings : public UGameUserSettings
{
	GENERATED_BODY()

public:
	UFUNCTION(BlueprintCallable, BlueprintPure, Category = "Legumix", meta = (Keywords = "Game User Settings, Settings, User Settings"))
	static ULMUserSettings* GetLegumixUserSettings();

	virtual void ApplySettings(bool bCheckForCommandLineOverrides) override;

	UPROPERTY(BlueprintCallable, BlueprintAssignable, category = "Legumix")
	FOnSettingsChangedSignature OnSettingsChanged;

public:
	UPROPERTY(Config, EditAnywhere, BlueprintReadWrite, Category = "Legumix|Audio", meta = (UIMin = 0, ClampMin = 0, UIMax = 100, ClampMax = 100))
	int MasterAudio = 100;
	UPROPERTY(Config, EditAnywhere, BlueprintReadWrite, Category = "Legumix|Audio", meta = (UIMin = 0, ClampMin = 0, UIMax = 10, ClampMax = 100))
	int MusicAudio = 100;
	UPROPERTY(Config, EditAnywhere, BlueprintReadWrite, Category = "Legumix|Audio", meta = (UIMin = 0, ClampMin = 0, UIMax = 100, ClampMax = 100))
	int FxAudio = 100;

	UPROPERTY(Config, EditAnywhere, BlueprintReadWrite, Category = "Legumix|Controls", meta = (UIMin = 0, ClampMin = 0, UIMax = 10, ClampMax = 10))
	float MouseSensitivity = 1.f;

	UPROPERTY(Config, EditAnywhere, BlueprintReadWrite, Category= "Legumix|Gameplay", meta = (UIMin = 60, ClampMin = 60, UIMax = 90, ClampMax = 90))
	float FieldOfView = 80.f;
};
