﻿#pragma once
#include "Ammo/LMAmmoType.h"
#include "LMBulletInfo.generated.h"

USTRUCT(BlueprintType)
struct FLMBulletInfo
{
	GENERATED_BODY()

	/** The number of bullets to fire. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	int BulletCount = 1;

	/** The bullets' origins. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FVector Origin = FVector::ZeroVector;

	/** The main direction vector. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FVector Direction = FVector::ForwardVector;

	/** The Random bullet spread angle deviation. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float Spread = 0.0f;

	/** The maximum distance before the bullet reaches minimum damages. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float MaxDistance = 100000.f;

	/** A curve multiplicating the damage of a bullet depending on the distance of the target. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	UCurveFloat* Falloff = nullptr;

	/** The type of bullet that was fired. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EAmmoType AmmoType = EAmmoType::EAT_CornAmmo;

	/** The default amount of damage to apply per bullet. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float Damage = 10.f;
};
